//last updated 30.06.2006


//---------------------------------------
//This unit will be created by ZIM-------
// 2006 All rights Reserved :)))--------
//---------------------------------------

unit hiImgScrollBar;

interface

{$I share.inc}

uses Messages, Windows, Share, Win, Kol;

type
  THBManager = packed record
    Normal: Kol.PBitmap;
    Over: Kol.PBitmap;
    Down: Kol.PBitmap;
    Bck: Kol.PBitmap;
    En: Kol.PBitmap;
  end;
  PHBManager = ^THBManager;

  ThiImgScrollBar = class(THIWin)
  private
    Bmp, Normal, Over, Down, Bck, En: PBitmap;
    btn, BmpDef: PBitmap;
    HB: HBRUSH;
    BX, BY, MX, MY, MD, Poss, Th_Pos, pbx: Integer;
    FBM: THBManager;
    FStep,FPos,FDelta: integer;
    procedure SetPosition;

    procedure _onMouseMove(Sender: PControl; var Mouse: TMouseEventData);
    procedure _onMouseUp(Sender: PControl; var Mouse: TMouseEventData);
    procedure _onMouseLeave(Sender: PObj);
    procedure _onMouseDown(Sender: PControl; var Mouse: TMouseEventData);
    procedure _OnPaint(Sender: PControl; DC: HDC);
    procedure _OnClick(Sender: PObj);
    procedure _OnResize(Sender: PObj);
    procedure _onMouseWheel(Sender: PControl; var Mouse: TMouseEventData); override;
    procedure CalcSize;

    procedure Drawer(X: integer);
    procedure Ref;
    procedure Clip;

    function Pos: integer;
    function GetPosition(px: integer): Integer;
    function GetTh_Math(mx: integer): integer;
  public
    _prop_AutoSize: byte;
    _prop_Draw: boolean;
    _prop_LeftMargin_: integer;
    _prop_RightMargin_: integer;
    _prop_TopMargin_: integer;
    _prop_Max: integer;
    _prop_Min: integer;
    _prop_Th_Cursor: integer;
    _prop_Position: integer;
    _prop_TransparentColor: integer;
    _prop_Kind: Byte;
    _prop_ScrollMode: Byte;
    _prop_Skip: Byte;
    _prop_ImgScrollBarMan: PHBManager;

    _data_Bitmap: THI_Event;
    _event_onClick: THI_Event;
    _event_onPosition: THI_Event;

    constructor Create(Parent: PControl);
    destructor Destroy; override;
    procedure Scale(DC: HDC);
    procedure Init; override;
    procedure Load;
    procedure _work_doPosition(var _Data: TData; Index: word);
    procedure _work_doMin(var _Data: TData; Index: word);
    procedure _work_doMax(var _Data: TData; Index: word);
    procedure _work_doEnabled(var _Data: TData; Index: word);

    procedure _var_Width(var _Data: TData; Index: word);
    procedure _var_Height(var _Data: TData; Index: word);
    procedure _var_Position(var _Data: TData; Index: word);
  end;

implementation

procedure ThiImgScrollBar._onMouseWheel(Sender: PControl; var Mouse: TMouseEventData);
var
  pos: integer;
  dt: TData;
  min,max,Data1,Data2: integer;
begin
  min := _prop_Min;
  max := _prop_Max;
  dt := _data_Empty;
  FPos := Poss;

  if _prop_Kind = 0 then
  begin
    Data1 := -120;
    Data2 := 120;
  end;

  if _prop_Kind = 1 then
  begin
    Data1 := 120;
    Data2 := -120;
  end;

  if (integer(Mouse.Shift)div $10000) = Data1 then
    begin
      if FPos > min then
      begin
        Dec(Poss,(FStep+FDelta)+1); //?
        _prop_Position := Poss;
        dtInteger(dt,Poss);
        _work_doPosition(dt,0);
        _hi_onEvent(_event_onPosition,Poss);
      end;
    end;

  if (integer(Mouse.Shift)div $10000) = Data2 then
    begin
      if FPos < max then
      begin
        Inc(Poss,FStep-(FDelta-1));
        _prop_Position := Poss;
        dtInteger(dt,Poss);
        _work_doPosition(dt,0);
        _hi_onEvent(_event_onPosition,Poss);
      end;
    end;
end;

procedure ThiImgScrollBar.CalcSize;
var
  l,r,c,w,h,i,j,Count,EndImg: integer;
  Size: integer;
  tmpBmp: PBitmap;
  pos: integer;
  dt: TData;
begin
  tmpBmp := NewBitmap(BmpDef.Width,BmpDef.Height);
  BmpDef.Draw(tmpBmp.Canvas.Handle,0,0);
  pos := Poss;
  dtInteger(dt,Pos);
  if _prop_Kind = 0 then //  
  begin
    Size := BmpDef.Width div 3;
    Bck.Width := Control.Width;
    Bck.PixelFormat := pf24Bit;
    Bmp.Width := Control.Width;
    Bmp.PixelFormat := pf24Bit;
    //  
    BitBlt(Bmp.Canvas.Handle,0,0,Size,Bmp.Height,tmpBmp.Canvas.Handle,0,0,SRCCOPY);
    BitBlt(Bck.Canvas.Handle,0,0,Size,Bmp.Height,tmpBmp.Canvas.Handle,0,0,SRCCOPY);

    Size := (BmpDef.Width div 3);
    Count := (Control.ClientWidth div Size);
    EndImg := Count;
    j := Size;
    for i := 1 to Count do // 
    begin
       BitBlt(Bmp.Canvas.Handle,j,0,Size,Bmp.Height,tmpBmp.Canvas.Handle,(Size),0,SRCCOPY);
       BitBlt(Bck.Canvas.Handle,j,0,Size,Bmp.Height,tmpBmp.Canvas.Handle,(Size),0,SRCCOPY);
       J := J + Size;
       if Count = EndImg then
       begin //  
         BitBlt(Bmp.Canvas.Handle,Control.Width-Size,0,Size,Bmp.Height,tmpBmp.Canvas.Handle,(Size*2),0,SRCCOPY);
         BitBlt(Bck.Canvas.Handle,Control.Width-Size,0,Size,Bmp.Height,tmpBmp.Canvas.Handle,(Size*2),0,SRCCOPY);
       end;

    end;

  end;

  if _prop_Kind = 1 then
  begin
    Size := BmpDef.Height div 3;
    Bck.Height := Control.Height;
    Bck.PixelFormat := pf24Bit;
    Bmp.Height := Control.Height;
    Bmp.PixelFormat := pf24Bit;
    //  
    BitBlt(Bmp.Canvas.Handle,0,0,Bmp.Width,Size,tmpBmp.Canvas.Handle,0,0,SRCCOPY);
    BitBlt(Bck.Canvas.Handle,0,0,Bmp.Width,Size,tmpBmp.Canvas.Handle,0,0,SRCCOPY);

    Size := BmpDef.Height div 3;
    Count := (Control.ClientHeight div Size);
    EndImg := Count;
    j := Size;
    for i := 1 to Count-1 do // 
    begin
      BitBlt(Bmp.Canvas.Handle,0,j,Control.Width,Size,tmpBmp.Canvas.Handle,0,(Size),SRCCOPY);
      BitBlt(Bck.Canvas.Handle,0,j,Control.Width,Size,tmpBmp.Canvas.Handle,0,(Size),SRCCOPY);
      J := J + Size;
      if Count = EndImg then
      begin //  
        BitBlt(Bmp.Canvas.Handle,0,Control.Height-Size,Bmp.Width,Size,tmpBmp.Canvas.Handle,0,(Size*2),SRCCOPY);
        BitBlt(Bck.Canvas.Handle,0,Control.Height-Size,Bmp.Width,Size,tmpBmp.Canvas.Handle,0,(Size*2),SRCCOPY);
      end;
    end;
  end;

  tmpBmp.Free;
  Control.Invalidate;
  _work_doPosition(dt,0);
  Ref;
  FStep := Round((abs(_prop_max) / 50));
  FPos := poss;
end;

procedure ThiImgScrollBar._OnResize(Sender: PObj);
begin
  CalcSize;
  //Control.Invalidate;
end;

constructor ThiImgScrollBar.Create;
begin
  inherited Create(Parent);
  Control := _NewControl(FParent,'ThiImgScrollBar', WS_VISIBLE or WS_CHILD or BS_PUSHLIKE or WS_TABSTOP,False,nil);
  Bmp := NewBitmap(0, 0);
  Normal := NewBitmap(0, 0);
  Over := NewBitmap(0, 0);
  Down := NewBitmap(0, 0);
  En := NewBitmap(0, 0);
  Bck := NewBitmap(0, 0);
  Btn := NewBitmap(0, 0);
  BmpDef := NewBitmap(0, 0);
  InitAdd(Load);
end;

destructor ThiImgScrollBar.Destroy;
begin
  Bmp.Free;
  Normal.Free;
  Over.Free;
  Down.Free;
  En.Free;
  Bck.Free;
  Btn.Free;
  BmpDef.Free;
  inherited;
end;

procedure ThiImgScrollBar.Load;
begin
  FBM := THBManager(_prop_ImgScrollBarMan^);
  if Assigned(@FBM) then
  begin
    Normal.Assign(FBM.Normal);
    Over.Assign(FBM.Over);
    Down.Assign(FBM.Down);
    Bck.Assign(FBM.Bck);
    En.Assign(FBM.En);
    bmp.Assign(Bck);
    BmpDef.Assign(bmp);
  end;

  Btn.Assign(Normal);
  CalcSize;
  Control.SetSize(bck.width, bck.height);
  SetPosition;
  with Bmp.Canvas{$IFNDEF F_P}^{$ENDIF} do
  begin
    Pen.Color := _prop_Color;
    Brush.Color := _prop_Color;
    Brush.BrushStyle := bsSolid;
    Rectangle(0, 0, Control.Width, Control.Height);
  end;
  if _prop_Kind = 0 then
  begin
    BX := _prop_LeftMargin_;
    BY := _prop_TopMargin_;
  end else begin
    BX := _prop_TopMargin_;
    BY := _prop_LeftMargin_;
  end;
  Drawer(Th_Pos);
  Ref;

  Control.OnClick := _OnClick;
  Control.OnPaint := _OnPaint;
  Control.OnMouseMove := _OnMouseMove;
  Control.OnMouseUp := _OnMouseUp;
  Control.OnMouseLeave := _OnMouseLeave;
  Control.OnMouseDown := _OnMouseDown;
  Control.OnResize := _OnResize;

  CalcSize;
end;

procedure ThiImgScrollBar.Init;
begin

  inherited;
  if _prop_Kind = 0 then
    Control.Style := Control.Style or WM_HSCROLL;
  if _prop_Kind = 1 then
    Control.Style := Control.Style or WM_VSCROLL;
end;

procedure ThiImgScrollBar._work_doMax;
begin
  _prop_Max := ToInteger(_Data);
end;


procedure ThiImgScrollBar._work_doMin;
begin
  _prop_Min := ToInteger(_Data);
end;

procedure ThiImgScrollBar._work_doPosition;
var
  prc, pos, dat: integer;
begin
  if _prop_Kind = 0 then begin
    pbx := 0;
    pos := ToInteger(_Data);
    prc := bck.width - _prop_RightMargin_ - btn.width;
    dat := (Round((prc * pos) / _prop_Max)) + _prop_LeftMargin_;
    BX := round(dat);
    Drawer(dat);
    FDelta := Poss - pos;
  end else
  begin
    pbx := 0;
    pos := ToInteger(_Data);
    prc := bck.height - _prop_RightMargin_ - btn.height;
    dat := (Round((prc * pos) / _prop_Max)) + _prop_LeftMargin_;
    BY := round(dat);
    Drawer(dat);
    FDelta := Poss - pos;
  end;
  ref;
end;

procedure ThiImgScrollBar._work_doEnabled;
begin
  Control.Enabled := ReadBool(_Data);
  if ReadBool(_Data) then Btn.Assign(Normal) else
    Btn.Assign(En);
  Ref;
end;

procedure ThiImgScrollBar._var_Width;
begin
  _Data.data_type := data_int;
  _Data.idata := Bmp.Width
end;

procedure ThiImgScrollBar._var_Height;
begin
  _Data.data_type := data_int;
  _Data.idata := Bmp.Height
end;

procedure ThiImgScrollBar._OnClick;
begin
  _hi_OnEvent(_event_onClick);
end;

procedure ThiImgScrollBar.Scale;
var
  r: TRect;
  k: real;
  function Rect(x1, y1, x2, y2: integer): TRect;
  begin
    Result.Left := X1; Result.Top := Y1;
    Result.Right := X2; Result.Bottom := Y2;
  end;
begin
  r := Control.ClientRect;
  if Bmp.Width > Bmp.Height then
  begin
    k := Bmp.Width / Bmp.Height;
    k := Control.Width / k;
    r.Top := (Control.Height - Round(k)) div 2;
    r.Bottom := Control.Height - r.Top;
    FillRect(dc, Rect(0, 0, r.right, r.top), HB);
    FillRect(dc, Rect(0, r.Bottom, r.right, Control.Height), HB);
  end
  else
  begin
    k := Bmp.Height / Bmp.Width;
    k := Control.Height / k;
    r.Left := (Control.Width - Round(k)) div 2;
    r.Right := Control.Width - r.Left;
    FillRect(dc, Rect(0, 0, r.Left, r.Bottom), HB);
    FillRect(dc, Rect(r.Right, 0, Control.Width, r.Bottom), HB);
  end;
  SetStretchBltMode(DC, STRETCH_DELETESCANS);
  Bmp.StretchDraw(DC, r);
end;

procedure ThiImgScrollBar._OnPaint;
begin
  Scale(DC);

  if Control.Enabled = True then Btn.Assign(Normal) else
  begin
    Btn.Assign(En);
    Ref;
  end;

end;

procedure ThiImgScrollBar.SetPosition;
var
  prc, pos, dat: integer;
begin
  if _prop_Kind = 0 then begin
    pos := _prop_Position;
    prc := bck.width - _prop_RightMargin_;
    Th_Pos := (Round((prc * pos) / _prop_Max)) + _prop_LeftMargin_;
    Drawer(dat);
  end else
  begin
    pos := _prop_Position;
    prc := bck.height - _prop_RightMargin_;
    Th_Pos := (Round((prc * pos) / _prop_Max)) + _prop_LeftMargin_;
    Drawer(dat);
  end;
end;

procedure ThiImgScrollBar._onMouseMove;
var b: smallint;
begin
  MX := Mouse.X;
  MY := Mouse.Y;

  if ((pos = 1) and (Mouse.Shift = 1)) or (MD = 1) then begin
    Btn.Assign(Down);
    BX := round(MX - pbx);
    BY := round(MY - pbx);
    if _prop_Kind = 0 then Drawer(MX) else
      Drawer(MY);
  end;

  if (pos = 1) and (Mouse.Shift = 0) then begin
    Btn.Assign(Over);
    Control.Cursor := _prop_Th_Cursor;
    Ref;
  end;

  if (pos = 0) and (Mouse.Shift = 0) then begin
    Btn.Assign(Normal);
    Control.Cursor := _prop_Cursor;
    Ref;
  end;

  if _prop_Kind = 0 then begin
    if ((Pos = 0) and (_prop_Skip = 0)) and (Mouse.Shift = 1) then Drawer(MX);
  end else begin
    if ((Pos = 0) and (_prop_Skip = 0)) and (Mouse.Shift = 1) then Drawer(MY);
  end;

  Ref;
  case Mouse.Shift of
    1: b := 0;
    2: b := 1;
    16: b := 2;
  else b := -1;
  end;
  _hi_OnEvent(_event_OnMouseMove, b);
end;

procedure ThiImgScrollBar._onMouseUp;
begin
  MD := 0;
  Btn.Assign(Normal);
  ClipCursor(nil);
  if _prop_ScrollMode = 1 then begin
    if _prop_Kind = 0 then _hi_OnEvent(_event_OnPosition, getposition(bx))
    else
      _hi_OnEvent(_event_OnPosition, getposition(by));
  end;
  Ref;
  _hi_OnEvent(_event_onMouseUp, integer(Mouse.Button) - 1);
end;

procedure ThiImgScrollBar._onMouseLeave;
begin
  MD := 0;
  Btn.Assign(Normal);
  Control.Cursor := _prop_Cursor;
  Ref;
end;

procedure ThiImgScrollBar._onMouseDown;
var
  C, X: integer;
begin
  Control.Focused := True;
  if ({(pos = 1) and }(_prop_Skip = 0) and (Mouse.Shift = 1)) then
  begin
    if _prop_Kind = 0 then
      pbx := Normal.Width div 2;//GetTh_Math(Mouse.X);

    if _prop_Kind = 1 then
      pbx := Normal.Height div 2;

    MD := 1;
    Clip;
    _onMouseMove(Control,Mouse);
  end;

  if (_prop_Skip = 1) and (Mouse.Shift = 1) then
  begin
    pbx := GetTh_Math(Mouse.X);
    MD := 1;

    Clip;
    _onMouseMove(Control,Mouse);
  end;

  _hi_OnEvent(_event_onMouseDown, integer(Mouse.Button) - 1);
end;

function ThiImgScrollBar.Pos;
var
  Pos: Tpoint;
begin
  if ((MX > (BX)) and (MX < ((BX) + btn.width))) and ((MY > BY) and (MY < (BY + Btn.Height))) then
    Result := 1
  else
    Result := 0;
end;

procedure ThiImgScrollBar.Drawer;
var
  bm: PBitmap;
  mmx, mmy, dat, xx: integer;
begin

  if _prop_Kind = 0 then begin //-------------------------------------------------------------------
    mmx := x;

    if bx < _prop_LeftMargin_ then bx := _prop_LeftMargin_;

    if (bx) > (Bck.width - _prop_RightMargin_ - btn.width) then bx := (Bck.width - _prop_RightMargin_ - btn.width);

    Bck.DrawTransparent(Bmp.canvas.Handle, 0, 0, _prop_TransparentColor);
    Btn.DrawTransparent(bmp.canvas.Handle, bx, _prop_TopMargin_, _prop_TransparentColor);
    BY := _prop_TopMargin_;
    Ref;
    Control.Invalidate;

  end;

  if _prop_Kind = 1 then begin //-------------------------------------------------------------------
    mmy := x;
    if by < _prop_LeftMargin_ then by := _prop_LeftMargin_;
    if (by) > (Bck.height - _prop_RightMargin_ - btn.height) then by := (Bck.height - _prop_RightMargin_ - Btn.height);

    Bck.DrawTransparent(Bmp.canvas.Handle, 0, 0, _prop_TransparentColor);
    Btn.DrawTransparent(bmp.canvas.Handle, _prop_TopMargin_, by, _prop_TransparentColor);
    BX := _prop_TopMargin_;
    Ref;
    Control.Invalidate
  end;




  if _prop_ScrollMode = 0 then begin
    if _prop_Kind = 0 then _hi_OnEvent(_event_OnPosition, getposition(bx))
    else
      _hi_OnEvent(_event_OnPosition, getposition(by));
  end;

end;

procedure ThiImgScrollBar.Ref;
var
  bm: PBitmap;
  mmx, mmy: integer;
begin
  if _prop_Kind = 0 then begin
    mmx := BX;
    if bx < _prop_LeftMargin_ then mmx := _prop_LeftMargin_;
    if bx > (Bck.width - _prop_RightMargin_) then mmx := (Bck.width - _prop_RightMargin_ - btn.width);

    Bck.DrawTransparent(Bmp.canvas.Handle, 0, 0, _prop_TransparentColor);
    Btn.DrawTransparent(bmp.canvas.Handle, mmx, _prop_TopMargin_, _prop_TransparentColor);
  end;

  if _prop_Kind = 1 then begin
    mmy := BY;
    if by < _prop_LeftMargin_ then mmy := _prop_LeftMargin_;
    if (by + pbx) > (Bck.height - _prop_RightMargin_ - btn.width) then mmy := (Bck.height - _prop_RightMargin_ - btn.height);

    Bck.DrawTransparent(Bmp.canvas.Handle, 0, 0, _prop_TransparentColor);
    Btn.DrawTransparent(bmp.canvas.Handle, _prop_TopMargin_, mmy, _prop_TransparentColor);
  end;

  Control.Invalidate;
end;

procedure ThiImgScrollBar.Clip;
var r: TRect;
begin
  r := Control.ClientRect;
  r.BottomRight := Control.Client2Screen(r.BottomRight);
  r.TopLeft := Control.Client2Screen(r.TopLeft);
  ClipCursor(@r);
end;

function ThiImgScrollBar.GetPosition;
var
  dat: integer;
begin
  if _prop_Kind = 0 then begin
    if px > (Control.width - _prop_RightMargin_) then px := (Control.width - _prop_RightMargin_);
    dat := round((_prop_Max * (px - _prop_LeftMargin_)) / (Control.Width - (_prop_LeftMargin_ + _prop_RightMargin_ + btn.width)));
    Poss := dat;
    Result := dat;
  end;

  if _prop_Kind = 1 then begin
    if px > (Control.height - _prop_RightMargin_) then px := (Control.height - _prop_RightMargin_);
    dat := round((_prop_Max * (px - _prop_LeftMargin_)) / (Control.height - (_prop_LeftMargin_ + _prop_RightMargin_ + btn.height)));
    Poss := dat;
    Result := dat;
  end;
end;

function ThiImgScrollBar.GetTh_Math;
var
  b: integer;
begin
  if _prop_Kind = 0 then begin
    if bx < _prop_LeftMargin_ then bx := _prop_LeftMargin_;
    b := mx - bx;
    Result := b;
  end;
  if _prop_Kind = 1 then begin
    if by < _prop_LeftMargin_ then by := _prop_LeftMargin_;
    b := my - by;
    Result := b;
  end;
end;

procedure ThiImgScrollBar._var_Position;
begin
  _Data.data_type := data_int;
  _Data.idata := Poss;
end;

end.
