unit hiImgScrollBarMan;

interface

uses
  Kol,Windows,Share,Debug;

type
  THBManager = packed record
    Normal: Kol.PBitmap;
    Over: Kol.PBitmap;
    Down: Kol.PBitmap;
    Bck: Kol.PBitmap;
    En: Kol.PBitmap;
  end;
  PHBManager = ^THBManager;

 ThiImgScrollBarMan = class(TDebug)
   private
     FBM: THBManager;
     procedure SetBack_Image(Value: HBITMAP);
     procedure SetNormal(Value: HBITMAP);
     procedure SetOver(Value: HBITMAP);
     procedure SetDown(Value: HBITMAP);
     procedure SetEnabled(Value: HBITMAP);
   public
     _prop_Name: string;
     constructor Create;
     destructor Destroy; override;
     function getInterfaceImagesScrollBarMan: pointer;
     property _prop_Th_Normal: HBITMAP write SetNormal;
     property _prop_Th_Over: HBITMAP write SetOver;
     property _prop_Th_Down: HBITMAP write SetDown;
     property _prop_Th_Enabled: HBITMAP write SetEnabled;
     property _prop_Bcknd_Img: HBITMAP write SetBack_Image;
     property BM: THBManager read FBM write FBM;
 end;


implementation

constructor ThiImgScrollBarMan.Create;
begin
  inherited Create;
  FBM.Normal := NewBitmap(0, 0);
  FBM.Over := NewBitmap(0, 0);
  FBM.Down := NewBitmap(0, 0);
  FBM.En := NewBitmap(0, 0);
  FBM.Bck := NewBitmap(0, 0);
end;

destructor ThiImgScrollBarMan.Destroy;
begin
  FBM.Normal.Free;
  FBM.Over.Free;
  FBM.Down.Free;
  FBM.En.Free;
  FBM.Bck.Free;
  inherited Destroy;
end;

function ThiImgScrollBarMan.getInterfaceImagesScrollBarMan: pointer;
begin
  Result := @FBM;
end;

procedure ThiImgScrollBarMan.SetBack_Image;
begin
  if Value = 0 then exit;
  FBM.Bck.Handle := Value;
end;

procedure ThiImgScrollBarMan.SetNormal;
begin
  if Value = 0 then exit;
  FBM.Normal.Handle := Value;
end;

procedure ThiImgScrollBarMan.SetOver;
begin
  if Value = 0 then exit;
  FBM.Over.Handle := Value;
end;

procedure ThiImgScrollBarMan.SetDown;
begin
  if Value = 0 then exit;
  FBM.Down.Handle := Value;
end;

procedure ThiImgScrollBarMan.SetEnabled;
begin
  if Value = 0 then exit;
  FBM.En.Handle := Value;
end;

end.
